%define LISTIN(TYPE, NUM, ARRAY, PY_AS)
%typemap (in) (int NUM, TYPE* ARRAY) {
    /* typemap (in) (int NUM, TYPE* ARRAY) */
    int i;
    PyObject* pyobj;

    if (!PyList_Check($input) && !PyTuple_Check($input)) {
        PyErr_SetString(PyExc_ValueError, "expecting a list or tuple.");
        return NULL;
    }
    $1 = PyList_Size($input);
    $2 = (TYPE*) malloc($1 * sizeof(TYPE));
    if ($2 == NULL) return NULL;

    for (i=0; i<$1; i++) {
        pyobj = PySequence_GetItem($input, i);
        $2[i] = PY_AS(pyobj);
        Py_DECREF(pyobj);  
    }
}

%typemap (freearg) (int NUM, TYPE* ARRAY) {
    /* typemap (freearg) (int NUM, TYPE* ARRAY) */
    if ($2) free($2);
}
%enddef

%define LISTCLEAR(TYPE, NUM, ARRAY)
%clear (int NUM, int* ARRAY);
%enddef
